# -*- coding: utf-8 -*-

import appuifw
import contacts
import e32
import inbox
import logs
import messaging

def exit_key_handler():
    app_lock.signal()

def message_received(id, box):
    box.sms_messages()
    sender = box.address(id)

    if sender[0] != '+' or sender[1:].isdigit() == False:
        # Try to find the sender's number from log.
        logged_sms = logs.sms(mode = 'in')[0]

        # To confirm that the log entry is the same one we're concerned
        # about, do some checks.
        if logged_sms['subject'] == sms_text[:64]:
            number = logged_sms['number']
            contacts_db = contacts.open()
            found_contact = contacts_db.find(number)
            if found_contact:
                title_match = True
                for token in sender.split():
                    if found_contact[0].title.find(token) == -1:
                        title_match = False
                if title_match:
                    sender = number

    print "SMS Received from: ", sender

if __name__ == "__main__":
    appuifw.app.title = u"Incoming SMS Number"

    box = inbox.Inbox()
    box.bind(lambda id: message_received(id, box))

    appuifw.app.exit_key_handler = exit_key_handler

    app_lock = e32.Ao_lock()
    app_lock.wait()

